import os
import sys

akami_version = 'alpha MacOS-darwin {1.0.0}'
class akami:
    def drop(functionname, pypath = sys.argv[0], shell = 'zsh'): 
        #functionname: name of the function for use in terminal
        #pypath: path to python file being extracted
        #shell: shell of the users computer temrinal

        #if code is run, the pypaths default is in the file the code is ran, else- a given path to any .py file
        #inputing the correct shell is fundamental for the fucntion to be implemented properly
        #if the user doesn't have a .zshrc or .bashrc file it can be created using 'touch ~/.bashrc' || 'touch ~/.zshrc'
        #once the function is run, restart the terminal and input the functionname to test results

        if shell != 'zsh' and shell != 'bash':
            raise SyntaxError('shell argument is invalid', 'shell must be either bash or zsh')

        #bashname file name
        bashname = str('.' + functionname + '.sh')

        #string-form function to call .py file for .sh implementation
        bashfuncstring = str('#!/bin/bash\n\nfunction ' + functionname + '(){\n  python3 ' + pypath +'\n}')

        #create .sh
        os.system('touch '+ bashname)
        
        #write py path into function in .sh
        funcfile = open(bashname,'w')
        funcfile.write(bashfuncstring)
        funcfile.close()

        #append .sh file to .zshrc
        if sys.platform == 'darwin':
            if shell.lower() == 'zsh':
                #obtains the .zshrc path in a flexible manner
                zshrcpath = '/'.join(tuple(sys.argv[0].split('/'))[0:3]) + '/.zshrc'

                if os.path.exists(zshrcpath):
                    #appends source to .zshrc
                    with open(zshrcpath) as zshrcfile:
                        if str(os.path.abspath(bashname)) not in zshrcfile.read():
                            zshrc = open(zshrcpath, 'a')
                            zshrc.write('\nsource ' + str(os.path.abspath(bashname)))
                            zshrc.close()
                else:
                    raise SyntaxWarning('~/.zshrc file does not exist','in order to create one, run: "touch .zshrc" in your terminal')

            elif shell.lower() == 'bash':
                #obtains the .bashrc path in a flexible manner
                bashrcpath = '/'.join(tuple(sys.argv[0].split("/"))[0:3]) + '/.bashrc'

                if os.path.exists(bashrcpath):
                    #appends source to .bashrc
                    with open(bashrcpath) as bashrcfile:
                        if str(os.path.abspath(bashname)) not in bashrcfile.read():
                            bashrc = open(bashrcpath, 'a')
                            bashrc.write('\nsource ' + str(os.path.abspath(bashname)))
                            bashrc.close()
                else:
                    raise SyntaxWarning('~/.bashrc file does not exist','in order to create one, run: "touch .bashrc" in your terminal')

            else:
                raise SyntaxWarning('shell is not recognized')

    def version():
        return("akami-version: "+akami_version)

    def methods():
        method_list = [method for method in dir(akami) if method.startswith('__') is False]
        return(method_list)